///////////////////////////////////////////////////////////////////
//   Fishgram Send/Receive                                       //
//   Created by Andrea S. Costa, December 9, 2016.               //
//   Listen for message sent to Telegram bot and reply to sender //
///////////////////////////////////////////////////////////////////


/*
Done! Congratulations on your new bot. You will find it at t.me/ChristmasTree_Bot. You can now add a description, about section and profile picture for your bot, see /help for a list of commands. By the way, when you've finished creating your cool bot, ping our Bot Support if you want a better username for it. Just make sure the bot is fully operational before you do this.

Use this token to access the HTTP API:
675024593:AAFgag3IjDFkiVN5wSnWG2dfqs0QH4dbGcM

For a description of the Bot API, see this page: https://core.telegram.org/bots/api

*/

//Libraries inclusion
#include <SPI.h>
#include <Fishino.h>
#include <JSONStreamingParser.h>
#include <FishGram.h>
#include <DFPlayer_Mini_Mp3.h>
#include <EEPROM.h>

#include <FastLED.h>



//#define DEBUG



#if defined(FASTLED_VERSION) && (FASTLED_VERSION < 3001000)
#warning "Requires FastLED 3.1 or later; check github for latest code."
#endif

#define DATA_PIN     5
#define NUM_LEDS    13
#define LED_TYPE    WS2811
#define COLOR_ORDER GRB
CRGB leds[NUM_LEDS];

#define BRIGHTNESS          200
#define FRAMES_PER_SECOND   200

// COOLING: How much does the air cool as it rises?
// Less cooling = taller flames.  More cooling = shorter flames.
// Default 50, suggested range 20-100 
#define COOLING  55

// SPARKING: What chance (out of 255) is there that a new spark will be lit?
// Higher chance = more roaring fire.  Lower chance = more flickery fire.
// Default 120, suggested range 50-200.
#define SPARKING 120



bool gReverseDirection = false;


/******* mp3******/
const int BUSY = 6;
SoftwareSerial mySerial(2, 3); // RX, TX


const int NUMERO_TRACCE = 1; //rappresenta il numero di tracce massime da eseguire sulla SD
const int MAX_VOL = 20; //volume massimo impostabile
int STEP_VOL = 3; //passi regolazione volume
boolean PLAY_START = true;  //true:riproduzione all'avvio - false:no riproduzione all'avvio
boolean PLAY_LOOP = true;  //true:riproduzione in Loop - false:no riproduzione in Loop
boolean wifilink= true;
int volume=0;
int vol=10;
int value=0;
int i=0;
#define ARRAY_SIZE(A) (sizeof(A) / sizeof((A)[0]))

//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
// CONFIGURATION DATA		-- ADAPT TO YOUR NETWORK !!!
// DATI DI CONFIGURAZIONE	-- ADATTARE ALLA PROPRIA RETE WiFi !!!
#ifndef __MY_NETWORK_H

// here pur SSID of your network
// inserire qui lo SSID della rete WiFi
#define MY_SSID	"**********" 

// here put PASSWORD of your network. Use "" if none
// inserire qui la PASSWORD della rete WiFi -- Usare "" se la rete non è protetta
#define MY_PASS	"********"

// here put required IP address (and maybe gateway and netmask!) of your Fishino
// comment out this lines if you want AUTO IP (dhcp)
// NOTE : if you use auto IP you must find it somehow !
// inserire qui l'IP desiderato ed eventualmente gateway e netmask per il fishino
// commentare le linee sotto se si vuole l'IP automatico
// nota : se si utilizza l'IP automatico, occorre un metodo per trovarlo !
#define IPADDR	192, 168,   0, 251
#define GATEWAY	192, 168,   0, 1
#define NETMASK	255, 255, 255, 0

// here put your bot's Telegram token -- see pdf instructions for setup
// inserire qui la token del bot Telegram -- vedere le istruzioni nel pdf allegato
#define MY_TELEGRAM_TOKEN "*********:***********************************" 

#endif
//                    END OF CONFIGURATION DATA                      //
//                       FINE CONFIGURAZIONE                         //
///////////////////////////////////////////////////////////////////////

// define ip address if required
// NOTE : if your network is not of type 255.255.255.0 or your gateway is not xx.xx.xx.1
// you should set also both netmask and gateway
#ifdef IPADDR
	IPAddress ip(IPADDR);
	#ifdef GATEWAY
		IPAddress gw(GATEWAY);
	#else
		IPAddress gw(ip[0], ip[1], ip[2], 1);
	#endif
	#ifdef NETMASK
		IPAddress nm(NETMASK);
	#else
		IPAddress nm(255, 255, 255, 0);
	#endif
#endif

uint8_t gCurrentPatternNumber = 0; // Index number of which pattern is current
uint8_t gHue = 0; // rotating "base color" used by many of the patterns
uint32_t tim;


void setup(void)
{
  pinMode(BUSY, INPUT);
	// Initialize serial and wait for port to open
	// Inizializza la porta seriale e ne attende l'apertura


   /****mp3*/
  mySerial.begin (9600);
  mp3_set_serial (mySerial);  //set softwareSerial for DFPlayer-mini mp3 module 
 



  
	Serial.begin(115200);
	
	// only for Leonardo needed
	// necessario solo per la Leonardo
	while (!Serial)
		;

  // tell FastLED about the LED strip configuration
  FastLED.addLeds<LED_TYPE,DATA_PIN,COLOR_ORDER>(leds, NUM_LEDS).setCorrection(TypicalLEDStrip);
  //FastLED.addLeds<LED_TYPE,DATA_PIN,CLK_PIN,COLOR_ORDER>(leds, NUM_LEDS).setCorrection(TypicalLEDStrip);

  // set master brightness control
  FastLED.setBrightness(BRIGHTNESS);

  
  leds[12] = CRGB::Red;
  FastLED.show();  
  
	// reset and test WiFi module
	// resetta e testa il modulo WiFi
	while(!Fishino.reset())
		Serial << F("Fishino RESET FAILED, RETRYING...\n");
	Serial << F("Fishino WiFi RESET OK\n");

	// go into station mode
	// imposta la modalità stazione
	Fishino.setMode(STATION_MODE);
	
	// set PHY mode to 11G
	// some new access points don't like 11B mode
	Fishino.setPhyMode(PHY_MODE_11G);

	// try forever to connect to AP
	// tenta la connessione finchè non riesce
  int timer=0;
	Serial << F("Connecting to AP...");
	while(!Fishino.begin(MY_SSID, MY_PASS) && (timer<=40))
	{
		Serial << ".";
		delay(500);
    timer++;
	}
	
 if (timer>39) {
  Serial << "Connection KO\n";
  wifilink=false;
  PLAY_START=false; //se non c'è connessione non faccio il play
 }
 else
 {
  Serial << "OK\n";
 }
	
	// setup IP or start DHCP client
	// imposta l'IP statico oppure avvia il client DHCP
#ifdef IPADDR
	Fishino.config(ip, gw, nm);
#else
	Fishino.staStartDHCP();
#endif

	// wait till connection is established
  timer=0;
	Serial << F("Waiting for IP...");
	while((Fishino.status() != STATION_GOT_IP)&& (timer<40))
	{
		Serial << ".";
		delay(500);
   timer++;
	}

  if (timer>39) {
  Serial << " Connection KO\n";
  wifilink=false;
  PLAY_START=false; //se non c'è connessione non faccio il play
 }
 else
 {
  Serial << "OK\n";
 }

	
	// print connection status on serial port
	// stampa lo stato della connessione sulla porta seriale
	printWifiStatus();

  leds[12] = CRGB::Yellow;
  FastLED.show();  
  
	
	// start FishGram
	FishGram.messageEvent(FishGramHandler);
	FishGram.begin(F(MY_TELEGRAM_TOKEN));
	
	tim = millis();




  gCurrentPatternNumber=EEPROM.read(2);
  #ifdef DEBUG 
    Serial << F("gCurrentPatternNumber ") << gCurrentPatternNumber << "\n";
  #endif  
  if (gCurrentPatternNumber>10) gCurrentPatternNumber = 0;

///// mp3
   delay(200);
  vol=EEPROM.read(1);
  if (vol>MAX_VOL) vol=MAX_VOL;
  setvolume(vol);
  //delay(200);

  leds[12] = CRGB::Green;
  FastLED.show();  

 //mp3_play (1);

  mp3_single_loop (false);
  
  if (PLAY_START==true) 
  {   
    playtrack(1);
    #ifdef DEBUG 
    Serial.println("Play");             
    #endif
    delay(200);
  }  

  
}

// List of patterns to cycle through.  Each is defined as a separate function below.
typedef void (*SimplePatternList[])();
//SimplePatternList gPatterns = { rainbow, rainbowWithGlitter, confetti, sinelon, juggle, bpm, Fire2012 };
SimplePatternList gPatterns = { rainbow, rainbowWithGlitter, confetti, sinelon, juggle, bpm};

 
void loop(void)
{
	// process FishGram data
  if (wifilink==true){
    FishGram.loop();  
  }
	
	
	if(millis() > tim)
	{
		Serial << F("Free RAM : ") << Fishino.freeRam() << "\n";
		tim = millis() + 3000;
	}

 // Call the current pattern function once, updating the 'leds' array
  gPatterns[gCurrentPatternNumber]();

  // send the 'leds' array out to the actual LED strip
  //FastLED.show();  
  FastLED.delay(1000/FRAMES_PER_SECOND); 

  // do some periodic updates
  EVERY_N_MILLISECONDS( 50 ) { gHue++; } // slowly cycle the "base color" through the rainbow
  //EVERY_N_SECONDS( 10 ) { nextPattern(); } // change patterns periodically

  boolean play_state = digitalRead(BUSY);
 // Serial << F("play_state: ") << play_state << "\n";
  if((play_state == HIGH) and (PLAY_LOOP == true)){
    mp3_next ();    
  }
  else
  {
    //Serial << F("play_state: LOWWWWWWWWWW") << play_state << "\n";
   // delay (2000); 
  }
  
}


// this one is optional, just to show wifi connection details
// questa è opzionale, solo per mostrare i dettagli della connessione wifi
void printWifiStatus()
{
  // print the SSID of the network you're attached to:
  // stampa lo SSID della rete:
  Serial.print("SSID: ");
  Serial.println(Fishino.SSID());

  // print your WiFi shield's IP address:
  // stampa l'indirizzo IP della rete:
  IPAddress ip = Fishino.localIP();
  Serial << F("IP Address: ");
  Serial.println(ip);

  // print the received signal strength:
  // stampa la potenza del segnale di rete:
  long rssi = Fishino.RSSI();
  Serial << F("signal strength (RSSI):");
  Serial.print(rssi);
  Serial << F(" dBm\n");
}

// fishgram event handler -- just display message on serial port
bool FishGramHandler(uint32_t id, const char *firstName, const char *lastName, const char *message)
{
  if(firstName)
    Serial << firstName << " ";
  else
    Serial << F("Nobody ");
  Serial << F("sent you-> ") << message << "\n";
  
  String ans = "Ciao ";
  ans += firstName;
  ans += ", ho ricevuto il tuo messaggio '";
  ans += message;
  ans += "'";
  //FishGram.sendMessage(id, ans.c_str());
  #ifdef DEBUG 
    Serial << F("Message-> ") << (message) << "\n";
    Serial << F("lenght-> ") << (sizeof(message)) << "\n";
    
  #endif
  if(strstr(message,"/play"))
  //if (!strcmp(message, "/play")) //playx
  {
    int track=message[5]-48;
    #ifdef DEBUG 
      Serial << F("MP3 ") << track << "\n";
    #endif
    if ((track>=1) && (track<=9)){
      #ifdef DEBUG 
        Serial << F("Play traccia ") <<(track) << "\n";
      #endif
    }
    else
    {
      track=1;
    }
    playtrack(track);
    String ans = F("Ok. Parte la riproduzione dell'mp3 numero ");
    ans += track;
    FishGram.sendMessage(id, ans.c_str());
    PLAY_LOOP = true;
    return true;
  }

  if (!strcmp(message, "/stop")) //playx
  {
    #ifdef DEBUG 
      Serial << F("MP3 stop") << "\n";
    #endif
    mp3_stop ();
    String ans = F("Ok. Fermo la musica");
    FishGram.sendMessage(id, ans.c_str());
    PLAY_LOOP = false;
    return true;
  }

  if (!strcmp(message, "/volup")) 
  {
    #ifdef DEBUG 
      Serial << F("volume +") << "\n";
    #endif  
    if (vol<MAX_VOL-STEP_VOL){
      vol=vol+STEP_VOL;
    }
    else
    {
      vol=MAX_VOL;
    }
    setvolume(vol);    
    String ans = F("Ok. Alzo il volume. Livello volume ");
    ans += vol;
    FishGram.sendMessage(id, ans.c_str());
    return true;
  }

  if (!strcmp(message, "/voldown")) 
  {
    #ifdef DEBUG 
      Serial << F("Volume -") << "\n";
    #endif  
    if (vol>STEP_VOL){
      vol=vol-STEP_VOL;
    }
    else
    {
      vol=0;
    } 
    setvolume(vol);  
    String ans = F("Ok. Abbasso il volume. Livello volume  ");
    ans += vol;
    FishGram.sendMessage(id, ans.c_str());
    return true;
  }
  
  if (!strcmp(message, "/next"))
  {
    #ifdef DEBUG 
      Serial << F("next") << "\n";
    #endif  
    mp3_next ();
    String ans = F("Ok. Riproduco la prossima canzone ");
    FishGram.sendMessage(id, ans.c_str());
    PLAY_LOOP = true;
    return true;
  }

  if (!strcmp(message, "/random"))
  {
    #ifdef DEBUG 
      Serial << F("random") << "\n";
    #endif  
    mp3_random_play ();
    String ans = F("Ok. Riproduco musica random ");
    FishGram.sendMessage(id, ans.c_str());
    PLAY_LOOP = true;
    return true;
  }

  if (!strcmp(message, "/rainbow"))
  {
    #ifdef DEBUG 
      Serial << F("rainbow") << "\n";
    #endif  
    gCurrentPatternNumber=0;
    String ans = F("Ok. Effetto Rainbow ");
    FishGram.sendMessage(id, ans.c_str());
    EEPROM.write(2, gCurrentPatternNumber);
    return true;
  }

  if (!strcmp(message, "/glitter"))
  {
    #ifdef DEBUG 
      Serial << F("glitter") << "\n";
    #endif
    gCurrentPatternNumber=1;
    String ans = F("Ok. Effetto Glitter ");
    FishGram.sendMessage(id, ans.c_str());
    EEPROM.write(2, gCurrentPatternNumber);
    return true;
  }

  if (!strcmp(message, "/confetti"))
  {
    #ifdef DEBUG 
     Serial << F("confetti") << "\n";
    #endif 
    gCurrentPatternNumber=2;
    String ans = F("Ok. Effetto Confetti ");
    FishGram.sendMessage(id, ans.c_str());
    EEPROM.write(2, gCurrentPatternNumber);
    return true;
  }

  if (!strcmp(message, "/sine"))
  {
    #ifdef DEBUG 
      Serial << F("Sine") << "\n";
    #endif
    gCurrentPatternNumber=3;
    String ans = F("Ok. Effetto Sine ");
    FishGram.sendMessage(id, ans.c_str());
    EEPROM.write(2, gCurrentPatternNumber);
    return true;
  }

    if (!strcmp(message, "/jungle"))
  {
    #ifdef DEBUG 
      Serial << F("jungle") << "\n";
    #endif
    gCurrentPatternNumber=4;
    String ans = F("Ok. Effetto Jungle ");
    FishGram.sendMessage(id, ans.c_str());
    EEPROM.write(2, gCurrentPatternNumber);
    return true;
  }

  if (!strcmp(message, "/bpm"))
  {
    #ifdef DEBUG 
      Serial << F("bpm") << "\n";
    #endif
    gCurrentPatternNumber=5;
    String ans = F("Ok. Effetto BPM ");
    FishGram.sendMessage(id, ans.c_str());
    EEPROM.write(2, gCurrentPatternNumber);
    return true;
  }


 /* if (!strcmp(message, "/fire"))
  {
    Serial << F("next") << "\n";
    gCurrentPatternNumber=6;
    String ans = F("Ok. Effetto Fire ");
    FishGram.sendMessage(id, ans.c_str());
    return true;
  }*/
  
  return true;
}










void nextPattern()
{
  // add one to the current pattern number, and wrap around at the end
  gCurrentPatternNumber = (gCurrentPatternNumber + 1) % ARRAY_SIZE( gPatterns);
}

void rainbow() 
{
  // FastLED's built-in rainbow generator
  fill_rainbow( leds, NUM_LEDS, gHue, 7);
}

void rainbowWithGlitter() 
{
  // built-in FastLED rainbow, plus some random sparkly glitter
  rainbow();
  addGlitter(80);
}

void addGlitter( fract8 chanceOfGlitter) 
{
  if( random8() < chanceOfGlitter) {
    leds[ random16(NUM_LEDS) ] += CRGB::White;
  }
}

void confetti() 
{
  // random colored speckles that blink in and fade smoothly
  fadeToBlackBy( leds, NUM_LEDS, 10);
  int pos = random16(NUM_LEDS);
  leds[pos] += CHSV( gHue + random8(64), 200, 255);
}

void sinelon()
{
  // a colored dot sweeping back and forth, with fading trails
  fadeToBlackBy( leds, NUM_LEDS, 20);
  int pos = beatsin16( 13, 0, NUM_LEDS-1 );
  leds[pos] += CHSV( gHue, 255, 192);
}

void bpm()
{
  // colored stripes pulsing at a defined Beats-Per-Minute (BPM)
  uint8_t BeatsPerMinute = 62;
  CRGBPalette16 palette = PartyColors_p;
  uint8_t beat = beatsin8( BeatsPerMinute, 64, 255);
  for( int i = 0; i < NUM_LEDS; i++) { //9948
    leds[i] = ColorFromPalette(palette, gHue+(i*2), beat-gHue+(i*10));
  }
}

void juggle() {
  // eight colored dots, weaving in and out of sync with each other
  fadeToBlackBy( leds, NUM_LEDS, 20);
  byte dothue = 0;
  for( int i = 0; i < 8; i++) {
    leds[beatsin16( i+7, 0, NUM_LEDS-1 )] |= CHSV(dothue, 200, 255);
    dothue += 32;
  }
}




void setvolume(int volume)
{
      mp3_set_volume(volume);
      #ifdef DEBUG 
        Serial.print("Vol ");
        Serial.println((volume));
      #endif  
      EEPROM.write(1, vol);
  
}

void playtrack(int track)
{
        #ifdef DEBUG 
          Serial.print("Playtrack: ");        
          Serial.println(track);
        #endif
        mp3_play(track);
        delay(100);
        //mp3_single_loop (false); 
        delay(100); 
        
}

